From a417065651f6ccfcfa68ad146832f2d08f38f027 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 16 2020 01:12:39 +0000
Subject: [PATCH 1410/2232] Emit pinned unique ptrs


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 3c9054c..bb93589 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -280,7 +280,10 @@ fn expand_cxx_function_shim(efn: &ExternFn, types: &Types) -> TokenStream {
                 quote!(#var.as_mut_ptr() as *const ::cxx::private::RustString)
             }
             Type::RustBox(_) => quote!(::std::boxed::Box::into_raw(#var)),
-            Type::UniquePtr(_) => quote!(::cxx::UniquePtr::into_raw(#var)),
+            Type::UniquePtr(ptr) => match ptr.pinned {
+                false => quote!(::cxx::UniquePtr::into_raw(#var)),
+                true => quote!(::cxx::UniquePtr::__pin_into_raw(#var)),
+            },
             Type::RustVec(_) => quote!(#var.as_mut_ptr() as *const ::cxx::private::RustVec<_>),
             Type::Ref(ty) => match &ty.inner {
                 Type::Ident(ident) if ident.rust == RustString => match ty.mutability {
@@ -374,7 +377,10 @@ fn expand_cxx_function_shim(efn: &ExternFn, types: &Types) -> TokenStream {
                         quote!(#call.into_vec())
                     }
                 }
-                Type::UniquePtr(_) => quote!(::cxx::UniquePtr::from_raw(#call)),
+                Type::UniquePtr(ptr) => match ptr.pinned {
+                    false => quote!(::cxx::UniquePtr::from_raw(#call)),
+                    true => quote!(::cxx::UniquePtr::__pin_from_raw(#call)),
+                },
                 Type::Ref(ty) => match &ty.inner {
                     Type::Ident(ident) if ident.rust == RustString => match ty.mutability {
                         None => quote!(#call.as_string()),
@@ -547,7 +553,10 @@ fn expand_rust_function_shim_impl(
                     quote!(::std::mem::take((*#ident).as_mut_vec()))
                 }
             }
-            Type::UniquePtr(_) => quote!(::cxx::UniquePtr::from_raw(#ident)),
+            Type::UniquePtr(ptr) => match ptr.pinned {
+                false => quote!(::cxx::UniquePtr::from_raw(#ident)),
+                true => quote!(::cxx::UniquePtr::__pin_from_raw(#ident)),
+            },
             Type::Ref(ty) => match &ty.inner {
                 Type::Ident(i) if i.rust == RustString => match ty.mutability {
                     None => quote!(#ident.as_string()),
@@ -591,7 +600,10 @@ fn expand_rust_function_shim_impl(
                 Some(quote!(::cxx::private::RustVec::from))
             }
         }
-        Type::UniquePtr(_) => Some(quote!(::cxx::UniquePtr::into_raw)),
+        Type::UniquePtr(ptr) => match ptr.pinned {
+            false => Some(quote!(::cxx::UniquePtr::into_raw)),
+            true => Some(quote!(::cxx::UniquePtr::__pin_into_raw)),
+        },
         Type::Ref(ty) => match &ty.inner {
             Type::Ident(ident) if ident.rust == RustString => match ty.mutability {
                 None => Some(quote!(::cxx::private::RustString::from_ref)),
diff --git a/src/unique_ptr.rs b/src/unique_ptr.rs
index 3a5fc66..283c2f1 100644
--- a/src/unique_ptr.rs
+++ b/src/unique_ptr.rs
@@ -7,6 +7,7 @@ use core::fmt::{self, Debug, Display};
 use core::marker::PhantomData;
 use core::mem;
 use core::ops::{Deref, DerefMut};
+use core::pin::Pin;
 use core::ptr;
 
 /// Binding to C++ `std::unique_ptr<T, std::default_delete<T>>`.
@@ -87,6 +88,16 @@ where
             ty: PhantomData,
         }
     }
+
+    #[doc(hidden)]
+    pub unsafe fn __pin_into_raw(ptr: Pin<UniquePtr<T>>) -> *mut T {
+        Self::into_raw(Pin::into_inner_unchecked(ptr))
+    }
+
+    #[doc(hidden)]
+    pub unsafe fn __pin_from_raw(raw: *mut T) -> Pin<Self> {
+        Pin::new_unchecked(Self::from_raw(raw))
+    }
 }
 
 unsafe impl<T> Send for UniquePtr<T> where T: Send + UniquePtrTarget {}
diff --git a/syntax/tokens.rs b/syntax/tokens.rs
index 40ab723..af8088d 100644
--- a/syntax/tokens.rs
+++ b/syntax/tokens.rs
@@ -40,6 +40,10 @@ impl ToTokens for Ty1 {
     fn to_tokens(&self, tokens: &mut TokenStream) {
         let span = self.name.span();
         let name = self.name.to_string();
+        if let Some((pin, langle, _rangle)) = self.pin_tokens {
+            tokens.extend(quote_spanned!(pin.span=> ::std::pin::Pin));
+            langle.to_tokens(tokens);
+        }
         if let "UniquePtr" | "CxxVector" = name.as_str() {
             tokens.extend(quote_spanned!(span=> ::cxx::));
         } else if name == "Vec" {
@@ -49,6 +53,9 @@ impl ToTokens for Ty1 {
         self.langle.to_tokens(tokens);
         self.inner.to_tokens(tokens);
         self.rangle.to_tokens(tokens);
+        if let Some((_pin, _langle, rangle)) = self.pin_tokens {
+            rangle.to_tokens(tokens);
+        }
     }
 }
 

